<template>
  <form @submit.prevent="sendMessage()">
    <input
      type="text"
      v-model="msgInput"
      class="shadow appearance-none border border-blue-500 rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
      placeholder="Send a message"
    />
    <button
      class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
    >
      Send
    </button>
  </form>
  <div class="show">
    <div v-for="(msg, key) in messages" :key="key" class="msg mb-2">
      <div class="msg__avatar">
        <img
          src="https://img5.thuthuatphanmem.vn/uploads/2021/12/06/anh-avatar-goku-ban-nang-vo-cuc_011149230.jpg"
          alt=""
        />
      </div>
      <div class="msg__content">
        <p>{{ msg.content }}</p>
        <span>{{ formatTime(msg.created_at) }}</span>
      </div>
    </div>
  </div>
</template>

<script setup>
import { onMounted, reactive, ref } from 'vue';
import socket from '@/plugins/socket.js';
import dayjs from 'dayjs';

const messages = reactive([]);
const msgInput = ref('');

socket.on('connect', () => {
  console.log(socket.connected);
});

onMounted(() => {
  socket.on('chat message', (msg) => {
    messages.push(msg);
  });
});

const formatTime = (time) => {
  return dayjs(time).format('MM.DD.YYYY HH:ii:mm');
};

const sendMessage = () => {
  if (msgInput.value.length === 0) return;

  const newMsg = { id: 1, content: msgInput.value, created_at: new Date() };

  messages.push(newMsg);

  socket.emit('chat message', newMsg);
  msgInput.value = '';
};
</script>

<style lang="scss" scoped>
.msg {
  display: flex;
  &__avatar {
    width: 40px;
    height: 40px;
    overflow: hidden;
    border-radius: 50%;
    margin-right: 10px;
    img {
      width: 100%;
    }
  }

  &__content {
    padding: 10px 20px;
    border-radius: 20px;
    background: #f1f1f1;
    p {
      margin-bottom: 0;
    }
  }

  &.rtl {
    justify-content: flex-end;

    .msg {
      &__avatar {
        order: 2;
        margin-right: 0;
      }

      &__content {
        order: 1;
        margin-right: 10px;
        p {
          text-align: right;
        }
      }
    }
  }
}
</style>
